unit uWebBrowser;

interface

uses
   SysUtils, Classes, Forms, ActiveX, ShDocVw, MSHTML;

procedure LoadHTMLintoWB(aWebBrowser: TWebBrowser; const aHTMLCode: String);
procedure ExecJSinWB(aWebBrowser: TWebBrowser; const javascript: String);

implementation

procedure LoadHTMLintoWB(aWebBrowser: TWebBrowser; const aHTMLCode: String);
var
   aPersistStreamInit: IPersistStreamInit;
   sl: TStringList;
   ms: TMemoryStream;
begin
   aWebBrowser.Navigate('about:blank');

   // pretend we're at localhost, so google doesn't complain about the API key
   (aWebBrowser.Document as IHTMLDocument2).URL := 'http://localhost';

   while aWebBrowser.ReadyState < READYSTATE_INTERACTIVE do
      Forms.Application.ProcessMessages;

   sl := TStringList.Create;
   try
      ms := TMemoryStream.Create;
      try
         sl.Text := aHTMLCode;
         sl.SaveToStream(ms);
         ms.Seek(0, 0);

         if Supports(aWebBrowser.Document, IPersistStreamInit, aPersistStreamInit) then
         begin
            if Succeeded(aPersistStreamInit.InitNew) then           /// without calling InitNew, I was getting intermittent error windows
               aPersistStreamInit.Load(TStreamAdapter.Create(ms));  ///   popping up, complaining something about Objects not existing in
         end;                                                       ///   for some windows dns error file
      finally
         ms.Free;
      end;
   finally
      sl.Free;
   end;
end;

procedure ExecJSinWB(aWebBrowser: TWebBrowser; const javascript: String);
var
   aHTMLDocument2: IHTMLDocument2;
begin
   if Supports(aWebBrowser.Document, IHTMLDocument2, aHTMLDocument2) then
      aHTMLDocument2.parentWindow.execScript(javascript, 'JavaScript');
end;

end.
